; bank 0 ($E000-$FFFF): Some space at $FF10-
; bank 5 ($C000-$DFFF): Space at $DEE0-
; bank 6 ($C000-$DFFF): Space at ~$DE90-
; bank 1C ($?000-$?FFF): Space? at ~$5DA0-$5FFF
; bank 1D ($?000-$?FFF): Space? at ~$5E50-$5FFF
; bank 1E ($?000-$?FFF): Space? at ~$5F50-$5FFF
; bank 1F ($4000-$5FFF): Space? at ~$5C80-$5FFF

	.nomlist
	.list

STAGE	= 0	;No stage jump

	.zp
mpr_spc EQU $F0		;A temporary variable for a mapper value
sgx_on	EQU $F1		;A flag (on=#$10) if SGX hardware exists
max_spr EQU $F2		;A variable for max hardware sprites
vpos	EQU $F3		;Vertical Positioning of screen variable
	.bss
;--- CODE area ----------
	.code
	.bank 0
	.incbin "R-TypeU.pce"
;-------------------------

	.bank 0		;E000-FFFF
	.org $E07E	;Right after memory clear and Mapping!
	jsr	SGX_Check 	;This is now in bank 5

	.org $E1AE	;Sets RCR for scanline $48
	lda	#$40    ;Change to $40

	.org $E1E6	;This is the scanline $48 (8) writing code!
	jsr	$E242	;Sets scrolling earlier.
	jmp	$E1F3   ;Don't clear scrolling.
	
	.org $E1F8	;Sets RCR for scanline $50
	lda	#$48	;Change to $48
	
	.org $E244
	jmp	Lv3TopFix

	.org $E24B	;Re-adjusts the Y-scroll offset
	sbc	#$10

	.org $E26C	;Scanline $50 code
	nop		;Stop scroll writing.
	nop
	nop
	
	.org $E2BC	;Scanline $48 code on level 3?
	nop
	nop
	nop

	.org $E2C8
	adc	#$50	;Top of Ship split on level 3!!!  (Level 1 also?????)
	
	.org $E34C	;Scanline $50 scrolling adjustment???
	jmp	FixLev3RCR
lE34F:	sec
	sbc	#$08
	sta	$0002
;	lda	$330A
;	adc	#$00

	.org $E377                ;This gets level 1 boss raster on-screen
	lda	#$10	;Was 18
	.org $E3D5                ;This positions the RCR properly.
	lda	#$1F	;Was 18	  ;What a pain in the ass!

        .org $E38E
        lda	#$DF	;Was D8 -- Size of ship on level 3????

	.org $E39D
	lda	#$D7	;Fix the blanking under the ship.

	.org $E3B4      ;RCR for floor of level 3
	adc	#$48

	.org $E43F	;This sets the RCR to $0118
	lda	#$1F    ;24 pixels down...

	.org $E47F	;Code here normally blanks sprites above line $50
	jsr	SprCut  ;Cut sprites in status bar

	.org $E492
	jsr	SprBackOn	;Turn on sprites again!

	.org $E68C
	lda	$3C22     	;Reverse the controller reading
	sta	$32D0		;Just to make it a bit easier on my code
	lda	$3C21
	jmp	scr_adjust

;SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS Stage select SSSSSSSSSSSSSSSSSSSSSSSSS
	IF (STAGE=3)
	.org $E7F8		;Stage select! (25D8, 25D9)
	lda	#$80
	sta	$25D8
	lda	#$1f
	ENDIF
;SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

	.org $F373
	jmp	Scr_ONOFF
	.org $F384
	jmp	Scr_ONOFF
	.org $F395
	jmp	Scr_ONOFF
;	.org $F417
;	jmp	Scr_ONOFF

	.org $F457      ;Joy Trigger reading
	jsr	cheat_routine
	
	.org $F469
	jmp	vdc_regs1
	nop
	.org $F475
	sta	$0000,X
	.org $F47B
	sta	$0002,X
	.org $F481
	sta	$0003,X
	.org $F48C
	sta	$0000,X
	stz	$0002,X
	stz	$0003,X
	.org $F499
	sta	$0000,X
	.org $F49F
	st1	#$00
	nop
	st2	#$00
	nop
	
	.org $F4AC		;Two routines to change H-Res
	st0	#$0A
;	st1	#$03
	st2	#$05
	st0	#$0B
	st1	#$27
	st2     #$07
        bbs4    <sgx_on,SGres	;If no SGX, normal write
	rts
SGres:	lda	#$01
	sta	$000E	;Turn on auto SGX indirect.
	st0	#$0A
;	st1	#$03
	st2	#$05
	st0	#$0B
	st1	#$27
	st2     #$07
	stz	$000E	;Clear auto SGX writes
	rts
	nop
	rts
	
lF4CF:  st0	#$0A
;	st1	#$03
	st2	#$03
	st0	#$0B
	st1	#$2B
	st2     #$06
        bbs4    <sgx_on,SGres2	;If no SGX, normal write
	rts
SGres2:	lda	#$01
	sta	$000E	;Turn on auto SGX indirect.
	st0	#$0A
;	st1	#$03
	st2	#$03
	st0	#$0B
	st1	#$2B
	st2     #$06
	stz	$000E	;Clear auto SGX writes
	rts

;************************************************ VRAM WRITE PATCHES!
	.org $F509
	.db	$0F		;Vertical synchro register (was #$0F)
	.db	$0D
	.db	$F1		;Vertical width register (was #$EF)

	.org $FC54
	jmp     VADD2_Write		;This writes progressively
					;to VRAM in-game!

	.org $FD0E
	jmp	VADDR_1         ;This sets up the writing address
	
	.org    $FD60       	;This writes data to the Vregs
	jmp	VDAT1_Write

;*****************************************************

	.org $FF10	;A *tiny* bit of free space
	
VADDR_1:
	bbs4    <sgx_on,.sgwrite	;If SGX on, do longer write
	lda	[$00],Y                 ;If not, replace the instruction
	iny
	jmp	$FD11			;And jump back
.sgwrite
;	lda	<$52			;Get the stored register
	sta	$0010			;Save to SGX too
	lda	[$00],Y                 ;
	iny
	sta	$0003
	stz	$0012
	sta	$0013
	lda	#$02
	sta	$0010
	jmp	$FD16           ;Back to the game

;MMMMMMMMMMMMMMMMMMMMMMMMMMMM Mapping Routines! MMMMMMMMMMMMMMMMMMMMMMMMMMM
MapMe:		;Maps some free space for Sprite writing code
	pha
	tma	#$02	;Get $4000-$5FFF region
	sta     <mpr_spc
	pla
	tam	#$02	;Map it in the correct space
	rts

UnMapMe:	;Puts the mapper back as before
	lda	<mpr_spc
	tam	#$02
	rts
;MMMMMMMMMMMMMMMMMMMMMMMMMMMM Mapping Routines! MMMMMMMMMMMMMMMMMMMMMMMMMMM

VADD2_Write:
	bbr4    <sgx_on,.no_sgregs0
	sta	$0010
.no_sgregs0
	lda	#$1C       	;Bank number
	bsr	MapMe           ;See above....
	jsr	VADD2_WriteBk	;A 2nd VRAM address write (in-game)
	bsr	UnMapMe
	jmp	$FC68

Lv3TopFix:           	;Make the ship appear in the first 8 scanlines!
	sta	$0000
        lda	$32D9
	cmp	#$03            ;Is it level 3?
	bne     .notl3
	lda     $32FE           ;Another nasty hack!
	cmp	#$05		;The RCR flags byte(?)
	bne	.notl3

	lda	#$1C       	;Bank number
	bsr	MapMe           ;See above....
	jsr	Lv3TopFixBk
	bsr	UnMapMe
	jmp	$E48B

.notl3	jmp	$E247   ;To regular scrolling routine


;***************************************************** INVINCIBILITY CHEATS **************************
cheat_routine:
	sta	$3C22   ;Load joy trigger
	and	#$04    ;Is Select pushed?
	beq	.no_invinc
	lda     $2166   ;Invincibility mode (or $2165)
	eor	#$01    ;ON/OFF
	sta	$2166
.no_invinc:
	lda	$3C22
AnRTS:	rts
;***************************************************** INVINCIBILITY CHEATS ***

scr_adjust:                     ;Slides the screen up or down via the VDC
	sta	$32CF		;This is our controller data
	lda     $32D6
	and	#$01		;Is the game paused?
	beq	AnRTS    ;If not, do nothing
	bbr0	<$3E,AnRTS	;Do only once every other frame
	jmp	vadj_cont1	;Continue this in BANK 5!!
;.no_adj_vpos:
;	rts

Scr_ONOFF:
	sta	$0002	;overwritten write
;	st2	#$00
        bbr4    <sgx_on,AnRTS
	lda	<$52;	#$05	;OK????
WrSg0:	sta     $0010	;SGX reg now
	lda	<$4E	;data
WrSg:	and	#$40	;sprites only!
	sta	$0012
	rts

SprCut:
	sta	$0002		;Write to VDP1
;	st2	#$00
        bbr4    <sgx_on,AnRTS	;If no SGX, jump to another RTS
;	stx	$0010		;Write our Reg
;	bra     WrSg		;Branch to already-existing code!
	rts

SprBackOn:
	sta	$0002
;	st2	#$00
        bbr4    <sgx_on,AnRTS
;        lda	#$05
;	bra	WrSg0		;Turn on sprites again...
	rts


FixLev3RCR:              	;Fixes the RCR used on level 3 and ALSO level 1!
	lda	$32D9
	cmp	#$03            ;Is it level 3?
	bne     .notl3
	lda     $32FE           ;Another nasty hack!
	cmp	#$03		;The RCR flags byte(?)
	beq	.next1
	lda	$32F2		;This is a nasty hack!
	cmp	#$28            ;Depending on the ship's pos...
	bpl     .notl3
.next1
        lda	$3309           ;Get scroll value
        clc
        adc	#$08		;Re-adjust it!
        bra	.here	;jmp     lE34F
.notl3:	lda	$3309          ;If not, resume
.here	jmp	lE34F


VDAT1_Write:
        bbr4    <sgx_on,.no_sgregs
	sta	$0012
.no_sgregs
	lda	$21D6,X
        bbr4    <sgx_on,.no_sgregs2
	sta	$0013
.no_sgregs2	jmp	$FD63

;*************************************************************************************************
    	.bank 1		;$4000-etc
    	.org $44DD
    	sbc	#$10
    	nop
    	nop
    	nop
    	nop
    	nop
    	nop
    	lda	#$10
    	sta	$2173

;    	.db	$9C	;Zero out the vertical scrolling routine!

;-------------------------

;*************************************************************************************************

;-------------------------

	.bank 2		;6000-etc
	.org $6BAF
	jmp	SAT_Code1 		;VRAM SAT Address
	
	.org $6BE4
	lda	#$55
	.org $6BF5
	cpx	#$30
	.org $6C03
	lda	#$54
	.org $6C0A
	ldx	#$55
	dex
	cpx	#$30
	.org $6C1A
	cpx	#$30
	
	.org $6C3B
	jmp     SAT_Code5		;Alternating zeroing-out
	
	.org $6C54
	jmp     SAT_Code2		;SPR-DMA start
	
	.org $6CFF
	lda	#$30			;Re-adjust sprite pos by 1 pixel

	.org $6D0F
	sbc	<$26	;#$10			;Scrolling sprites hack!
	jmp	SAT_Code3		;Alternating Write 1
	
	.org $6D6A
	jmp	SAT_Code4               ;Alternating Write 2

;-------------------

;*************************************************************************************************

	.bank $5
	.org  $DEE0
	
;************************************************ VDC Setup *********
vdc_regs1:
	lda	#$F2
	sta	<$00		;These 4 bytes get overwritten
	ldx	<sgx_on 	;1st run is either to VDC or PCE VDC
	bbr4    <sgx_on,.no_sgregs
	lda	#$01
	sta	$000E		;Turn on st0, st1, st2 for VDC2
	jsr	$F46D
	stz	$000E
	clx
.no_sgregs
	jmp     $F46D	;The VDC setup routine.
;************************************************ SGX Check **************************
SGX_Check:
	sta	$32E2
	lda	$F509		;This is where the vertical pos. constant is stored!
	sta	<vpos		;Store in our temp variable

	lda	#$40
	sta	<max_spr	;Max sprites are 64!
	stz	<sgx_on
	lda	#$F9
	tam	#2		;Map SGX RAM into $4000

	lda	#$2C
	sta	$4000		;Save in SG-RAM
	lda	$2000		;Is it mirrored?
	cmp	#$2C
	beq	.No_SG_Setup	;If different, it's an SGX, maybe.
	smb4	<sgx_on		;Make it "10"
	lda	#$80
	sta	<max_spr	;Max sprites are 128!
	bsr	VPC_Init	;Init the VPC for SGX mode
.No_SG_Setup:
;	.db	$43,$80,$85,$3F		;This is the code that SGX Check skipped...
	tma	#3	;Get higher mapper reg
	dec	a
	tam	#2	;Restore mapper
	rts

VPC_Init:		;Initialize the SGX Video Priority Controller
	lda	#$05
	sta	$0010
	lda	#$00
	sta	$0012	;Turn off SG screen
	lda	#%01110111 	;All sprites in front!!
	sta	$0008	;Set up Video Priority Controller
	sta	$0009
	stz	$000A
	stz	$000B
	stz	$000C
	stz	$000D
	stz	$000E
	lda	#$0F 	;DMA register
	sta	$0010
	stz     $0012	;Turn off automatic sprite SATB transfer
	stz	$0013
	rts

vadj_cont1:		;a continuation of the screen adjustment routine
	lda	$32CF		;Get cont.data again
	cmp	#$41            ;This is Down+1
	bne	.no_dn_scr
	lda	<vpos
	inc	a
	sta	<vpos
	cmp     #$1A		;This is the "lower limit" of the screen!
	bne	.write_regs
	dec	<vpos
	bra     .write_regs
.no_dn_scr:
	cmp	#$11           ;This is Up+1
	bne     .no_adj_vpos
	lda	<vpos
	dec	a
	sta	<vpos
	cmp     #$0B		;This is the "upper limit" of the screen!
	bne	.write_regs
	inc	<vpos
.write_regs:
	lda	#$0C
	sta	$0000
	bbr4    <sgx_on,.no_sgregs1
	sta	$0010
.no_sgregs1
	lda	<vpos
	sta	$0003
	bbr4    <sgx_on,.no_adj_vpos
	sta	$0013
.no_adj_vpos:
	rts
	

;*************************************************************************************************

	.bank $06
	.org $D10C

	CMP #$07	;X title messages more!

	.bank $10

	.org $5818	;Addr for "FRO"
	.dw	Msg_NEC1
	.dw	Msg_IREM
	.dw	Msg1
	.dw	Msg2

	.org $5878
Msg_NEC1:
	.dw	$0480+$09
	.db     $00
	.db 	"FROM NEC",0
Msg_IREM:
	.dw	$04C3
	.db	$00
	.db     $7E,"@ 1989 IREM CORP.",0
Msg1:
	.dw	$03ED	;Screen Positioning!
	.db	$20	;which palette to use!
	.db	"UNFINISHED SGX HACK",0
Msg2:
	.dw	$042D
	.db	$00
	.db	"2011 CHRIS COVELL",0



;*************************************************************************************************

	.bank $1C
	.org $5DA0

VADD2_WriteBk:
	lda	$2E28,X
	stz	$0002
	sta	$0003
	bbr4    <sgx_on,.no_sgregs1
	stz	$0012
	sta	$0013
.no_sgregs1
	inc     a
	sta	$2E28,X
	lda	#$02
	bbr4    <sgx_on,.no_sgregs2
	sta	$0010
.no_sgregs2
	sta	<$52
	sta	$0000
	rts

Lv3TopFixBk:
	lda	$32F2		;Get Y-pos of ship
	sec
	sbc	#$10
	sta	$0002
	lda     $32F3
	sbc	#$00
	sta	$0003
	st0	#$07	;Write to VDC reg 7
;	lda	#$07
;	sta	$0000
	lda	$32EE          ;Get X-pos of ship
	sta	$0002
	lda	$32EF
	sta	$0003
	rts
;*************************************************************************************************

	.bank $1F 	;This bank is safely in place when the game does Sprite Logic!
	.org $5C80

SAT_Code1:
	bbr4    <sgx_on,.skip1	;If no SGX, skip
	sta	$0010
;	lda	#$00
;	sta	$0002
	stz	$0012
.skip1	st1	#$00		;Write 0 to 0002
	st2	#$08           ;Point to $0800 where the SAT table will be.
	bbr4    <sgx_on,.skip2	;If no SGX, skip
	lda	#$08
	sta	$0013
.skip2
	lda	#$02
	sta	<$52
	sta	$0000
	bbr4    <sgx_on,.skip3	;If no SGX, skip
	sta	$0010
.skip3
	stz	<$14
	lda	<max_spr	;#$80		;Hardware sprite limit.  Change this!!!!!!!!!!!
	jmp	$6BC4

SAT_Code2:
;	lda	#$00
;	stz	$0002
	st1	#$00
	st2	#$08
;	lda	#$08
;	sta	$0003

	bbr4    <sgx_on,.skip21	;If no SGX, skip
;	lda	#$13
	sta	$0010		;Acc was preserved thanks to the ST0,1,2 instructions.
	stz	$0012
	lda	#$08
	sta	$0013
.skip21	jmp	$F360		;SPR SAT Exit point!

SAT_Code3:
	bbr4    <sgx_on,.no_sgwr	;If no SGX, normal write
	bbr0	<$15,.no_sgwr		;If even sprites, normal write
	sta	$0012
	lda	<$0F
	sbc	#$00
	sta	$0013                   ;The following code is a copy of $6DXX
	lda	<$10
	sta	$0012
	lda	<$11
	sta	$0013
	lda	[$00],Y
	stz	<$0F
	asl     a
	rol	<$0F
	.db	$B3,$FF,$43,$26		;tst	#$FF, $2643
	bne	.l6D41
	clc
	adc	#$60
	sta	$0012
	lda	<$0F
	adc	#$00
	sta	$0013
	bra	.l6D4D
.l6D41	adc	#$E0
	sta	$0012
	lda	<$0F
	adc	#$01
	sta	$0013
.l6D4D	iny
	jmp	$6D4E

.no_sgwr:
	sta	$0002
	jmp	$6D14

SAT_Code4:
	bbr4    <sgx_on,.no_sgwr	;If no SGX, normal write
	bbr0	<$15,.no_sgwr		;If even sprites, normal write
	sta	$0012
	lda	[$00],Y
	and	#$B9
	eor	<$06
	sta	$0013
	jmp	$6D76

.no_sgwr:
	sta	$0002
	jmp	$6D6D

SAT_Code5:
	dec	<$15			;We need this!
        bbr4    <sgx_on,.no_sgwr	;If no SGX, normal write
	bbs0	<$15,.no_sgwr		;If even sprites, normal write
	stz	$0012
	stz	$0013
	stz	$0013
	stz	$0013
	stz	$0013
	jmp	$6C4A

.no_sgwr:
	stz	$0002
	jmp	$6C3E